Controllers/WhitelistDomainsController.cs
using GameDistribution.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Mvc;
using System.Xml.Linq;

namespace GameDistribution.Controllers
{
    [Authorize(Roles = "SuperAdmin,Admin")]
    public class WhitelistDomainsController : Controller
    {

        GameDistributionEntitiesDataContext context = new GameDistributionEntitiesDataContext();

        // GET: WhitelistDomains
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult UnPublishedDomains(string id)
        {
            try
            {
                ViewBag.UnPublishedGameId = id;
                ViewBag.Game = context.GetGameDetailByMd5Id(id).FirstOrDefault().Title;

                return View();
            }
            catch
            {
                return RedirectToAction("NotFound", "Error");
            }

        }

        public ActionResult UnPublishedGames(string id)
        {
            return RedirectToAction("UnPublishedGames", "Games", new { id = id });
        }

        [HttpGet]
        public ActionResult Edit(int id)
        {
            //VGD-144
            var item = context.ADM_GetDomainByDomainId(id).FirstOrDefault();

            if (item == null)
                return null;

            var viewResult = new DomainViewModel();

            viewResult.Domain = item.Domain;
            viewResult.PreRoll = item.PreRoll;
            viewResult.BannerEnable = item.BannerEnable;
            viewResult.ShowAfterTime = item.ShowAfterTime;

            return View(viewResult);
        }

        [HttpPost]
        public ActionResult UpdateDomain(DomainViewModel domainView)
        {
            // VGD - 144
            //context.ADM_UpdateBannersByDomain(Utils.Utils.TrimDomain(domainView.Domain),
            //                                 domainView.BannerEnable == null ? false : domainView.BannerEnable,
            //                                 domainView.PreRoll == null ? false : domainView.PreRoll,
            //                                 domainView.ShowAfterTime == null ? 0 : domainView.ShowAfterTime);

            context.ADM_UpdateBannersByDomain(domainView.Id,
                                          domainView.BannerEnable == null ? false : domainView.BannerEnable,
                                          domainView.PreRoll == null ? false : domainView.PreRoll,
                                          domainView.ShowAfterTime == null ? 0 : domainView.ShowAfterTime);

            //going to be deleted at vgd-144
            //context.ADM_UpdateDomainNameById(domainView.Id,domainView.Domain);

            return View("index");
        }

        public ActionResult Delete(int id)
        {
            var item = context.ADM_Delete_WhiteListDomain(id);
            return View("Index");
        }

        public JsonResult GetWhiteListDomains(string sortdatafield, string sortorder, int pagesize, int pagenum)
        {
            var query = Request.QueryString;
            var item = context.ExecuteQuery<view_WhitelistDomain>(Utils.Utils.BuildQuery(query, "select * from view_WhitelistDomains")).OrderByDescending(g => g.AddedDate).ToList();
            IEnumerable<view_WhitelistDomain> whiteListDomains = from domain in item
                                                                 select new view_WhitelistDomain
                                                                 {
                                                                     Id = domain.Id,
                                                                     AdNetworkId = domain.AdNetworkId,
                                                                     Domain = domain.Domain,
                                                                     AddedDate = domain.AddedDate,
                                                                     HtmlBanner = domain.HtmlBanner,
                                                                     FamobiId = domain.FamobiId,
                                                                     Active = domain.Active,
                                                                     SyncTunnl = domain.SyncTunnl
                                                                 };
            var total = item.Count();
            whiteListDomains = whiteListDomains.Skip(pagesize * pagenum).Take(pagesize);
            if (sortdatafield != null && sortorder != "")
            {
                whiteListDomains = Utils.Utils.SortOrders<view_WhitelistDomain>(whiteListDomains, sortdatafield, sortorder);
            }
            var result = new
            {
                TotalRows = total,
                Rows = whiteListDomains
            };
            return Json(result, JsonRequestBehavior.AllowGet);

        }

        public JsonResult UpdateDomainsInline(view_WhitelistDomain result)
        {
            context.ADM_UpdateWhitelistDomains(result.Id,
                                              //result.Domain,
                                              result.HtmlBanner,
                                              int.Parse(result.Active.ToString()),
                                              result.FamobiId);

            return Json(true, JsonRequestBehavior.AllowGet);

        }

        public JsonResult AddDomains(string data)
        {
            string[] domains = data.Split('\n');
            XDocument xml = new XDocument(new XElement("Domains"));

            foreach (var item in domains)
            {
                xml.Root.Add(new XElement("Row", new XElement("Domain", item)));
                CreateDomainApi(item);
            }

            context.APP_WhiteListDomainAdd(1, xml.Root);

            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetUnPublishedDomains(string id, string sortdatafield, string sortorder, int pagesize, int pagenum)
        {
            try
            {
                var query = Request.QueryString;
                string filterValue = Request.QueryString["filtervalue0"];
                string filterField = Request.QueryString["filterdatafield0"];

                IEnumerable<ADM_GetUnPublishedDomainsByGameMD5Result> data = context.ADM_GetUnPublishedDomainsByGameMD5(id).OrderByDescending(x => x.CreatedDate).ToList();
                if (!string.IsNullOrEmpty(filterValue))
                {
                    if (filterField == "AffiliateId")
                    {
                        data = data.Where(x => x.AffiliateId.Contains(filterValue));
                    }
                    else if (filterField == "Domain")
                    {
                        data = data.Where(x => x.Domain.Contains(filterValue));
                    }
                }
                var total = data.Count();
                data = data.Skip(pagesize * pagenum).Take(pagesize).ToList();


                var result = new
                {
                    TotalRows = total,
                    Rows = data
                };


                return Json(result, JsonRequestBehavior.AllowGet);
            }
            catch
            {
                return Json("", JsonRequestBehavior.AllowGet);
            }
        }

        public void CreateDomainApi(string url)
        {
            try
            {
                using (var http = new System.Net.Http.HttpClient())
                {
                    //Create Partner
                    string createGameTagRequest = @"{
                                                    ""Session"":{
                                                    ""Token"":""1356b0be-8156-4dae-97d4-4d573d6c3b88""
                                                    },
                                                    ""Data"":{
                                                    ""Url"":'" + url + @"',
                                                    ""AdTagType"":'" + 1 + @"',
                                                    }
                                                }";
                    var content = new StringContent(createGameTagRequest);
                    content.Headers.ContentType = new System.Net.Http.Headers.MediaTypeHeaderValue("application/json");

                    var request = http.PostAsync("http://api.tunnl.com:8080/Platform/CreatePlatform", content);
                    var response = request.Result.Content.ReadAsStringAsync().Result;
                    InsertLog(url, response);
                }
            }
            catch
            {
                //string deneme = ex.Message;
            }

        }

        public void InsertLog(string url, string jsonString)
        {
            using (GameDistributionEntitiesDataContext context = new GameDistributionEntitiesDataContext())
            {
                TunnlLogDataModel log = Newtonsoft.Json.JsonConvert.DeserializeObject<TunnlLogDataModel>(jsonString);
                context.AddTunnlLog(2, url, log.ResponseCode, log.ResponseText, log.IsValid == true ? log.Data.Id : 0, log.IsValid);
            }
        }
    }
}

Views/WhitelistDomains/Edit.cshtml
@model GameDistribution.Models.DomainViewModel

@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="column" style="width:200px !important; margin-top:-15px;">
    @using (Html.BeginForm("UpdateDomain", "WhitelistDomains"))
    {
        @Html.HiddenFor(model => model.Id)
        @Html.HiddenFor(model => model.GameId)

        //VGD-144
        <div style="margin-top:15px;">
            @Html.Label("Advertisements")
            <div class="clipboard">
                @Html.EditorFor(model => model.BannerEnable, new { htmlAttributes = new { @Id = "chkAdv" } })
                <button id="btnAdvId" onclick="ResetBySettingType(this)" type="button">Reset</button>
            </div>
        </div>
        <div style="margin-top:15px;">
            @Html.Label("Enable PreRoll")
            <div class="clipboard">
                @Html.EditorFor(model => model.PreRoll, new { htmlAttributes = new { @Id = "chkPreRoll" } })
                <button id="btnPreId" onclick="ResetBySettingType(this)" type="button">Reset</button>
            </div>
        </div>
        <div style="margin-top:15px;">
            @Html.Label("Advertisement request (minute)")
            <div class="clipboard">
                @Html.EditorFor(model => model.ShowAfterTime, new { htmlAttributes = new { @class = "form-control" } })
                <button id="btnTimeId" onclick="ResetBySettingType(this)" type="button">Reset</button>
            </div>
        </div>

        <div style="margin-top:15px;">
            <button type="submit" onclick="return Confirmation(this)" class="button active" style="text-align:center">Save</button>
        </div>

    }
</div>

<script>

    //VGD-144
    $(document).ready(function () {
        if ('@(Model.BannerEnable)' != "") { $("#chkAdv option:contains('Not Set')").remove() }
        if ('@(Model.PreRoll)' != "") { $("#chkPreRoll option:contains('Not Set')").remove() }

        function Confirmation(obj) {
            return confirm('The changes will be effect to all individual settings. Do you want to change settings?');
        }
    });

</script>

Views/WhitelistDomains/Index.cshtml
@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section scripts{
    <script>
        $(document).ready(function () {
            $("#jqxwindow").jqxWindow({ height: 390, width: 675, theme: 'summer', isModal: true, autoOpen: false });
            $("#addrowbutton").click(function () {
                $("#jqxwindow").jqxWindow('open');
            });
            $("#button_input").click(function () {
                var data = $("#text_input").val();
                var dataValue = {
                    "data": data
                };
                $.ajax({
                    type: 'GET',
                    dataType: 'text',
                    url: '/WhitelistDomains/AddDomains',
                    data: dataValue,
                    contentType: "application/json; charset=utf-8",
                    success: function (data, status, xhr) {
                        // update command is executed.
                        $("#jqxgrid").jqxGrid('refreshdata');
                    },
                    error: function () {
                        // cancel changes.
                    }
                });

                $("#jqxwindow").jqxWindow('close');
            });
            $("#button_no").click(function () {
                $("#jqxwindow").jqxWindow('close');
            });
            var source =
                {
                    datafields:
                    [
                        { name: 'Id', type: 'number' },
                        { name: 'Domain', type: 'string' },
                        { name: 'AddedDate', type: 'date' },
                        { name: 'HtmlBanner', type: 'number' },
                        { name: 'Visible', type: 'number' },
                        { name: 'FamobiId', type: 'string' },
                        { name: 'Session', type: 'string' },
                        { name: 'AdRequest', type: 'number' },
                        { name: 'Active', type: 'number' },
                        { name: 'SyncTunnl', type: 'string' },
                        { name: 'R1', type: 'number' }

                    ],
                    updaterow: function (rowid, rowdata, commit) {
                        // synchronize with the server - send update command
                        var data = "update=true&Id=" + rowdata.Id + "&Active=" + rowdata.Active + "&HtmlBanner=" + rowdata.HtmlBanner + "&FamobiId=" + rowdata.FamobiId;

                        $.ajax({
                            dataType: 'json',
                            url: '/WhitelistDomains/UpdateDomainsInline',
                            data: data,
                            success: function (data, status, xhr) {
                                // update command is executed.
                                $("#jqxgrid").jqxGrid('refreshdata');
                                commit(true);
                            },
                            error: function () {
                                // cancel changes.
                                commit(false);
                            }
                        });
                    },
                    addrow: function (rowid, rowdata, position, commit) {
                        // synchronize with the server - send insert command
                        // call commit with parameter true if the synchronization with the server is successful
                        //and with parameter false if the synchronization failed.
                        // you can pass additional argument to the commit callback which represents the new ID if it is generated from a DB.
                        commit(true);
                    },
                    datatype: "json",
                    url: "/WhitelistDomains/GetWhiteListDomains",
                    filter: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'filter');
                    },
                    // update the grid and send a request to the server.
                    sort: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'sort');
                    },
                    root: "Rows",
                    beforeprocessing: function (data) {
                        source.totalrecords = data.TotalRows;
                    }
                };

            var isEditable = function (row) {
                return false;
            }

            var dataAdapter = new $.jqx.dataAdapter(source);

            var columnsrenderer = function (value) {
                return '<div style="text-align: center; margin-top:5px;"><b>' + value + '</b></div>';
            }

            var syncRenderer = function (row, columnfield, value, defaulthtml, columnproperties) {
                var color = value == "NOK" ? "red" : "green";
                return '<div style="text-align: center; margin-top:5px;color:' + color + ';">' + value + '</div>';
            }

            var cellsrenderer = function (row, columnfield, value, defaulthtml, columnproperties) {
                return '<div style="margin-left: 10px; margin-top:5px;">' + value + '</div>';
            }

            $("#jqxgrid").jqxGrid(
                {
                    width: "100%",
                    height: 650,
                    source: dataAdapter,
                    showfilterrow: true,
                    editable: true,
                    filterable: true,
                    pageable: true,
                    sortable: true,
                    pagesize: 20,
                    autoheight: true,
                    selectionmode: 'multiplecellsextended',
                    enablebrowserselection: true,
                    virtualmode: true,
                    rendergridrows: function (obj) {
                        return obj.data;
                    },
                    showtoolbar: true,
                    rendertoolbar: function (toolbar) {
                        var me = this;
                        var container = $("<div style='margin: 5px;'></div>");
                        toolbar.append(container);
                        container.append('<input id="addrowbutton" type="button" value="Add Domains" />');
                        $("#addrowbutton").jqxButton();
                        $("#addrowbutton").click(function () {
                            $("#jqxwindow").jqxWindow('open');
                        });
                    },
                    columns: [
                        { text: 'Id', datafield: 'Id', filtertype: 'textbox', hidden: true },
                        { text: 'Domain', datafield: 'Domain', filtertype: 'textbox', width: '18%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Session', datafield: 'Session', filtertype: 'textbox', width: '8%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Ad Request', datafield: 'AdRequest', filtertype: 'textbox', width: '9%', cellsrenderer: cellsrenderer, renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                         {
                             text: 'Html Banner', datafield: 'HtmlBanner', filtertype: 'textbox', cellsalign: 'center', width: '8%', renderer: columnsrenderer, sortable: true,
                             validation: function (cell, value) {
                                 if (value > 1 || value < 0) {
                                     return { result: false, message: "Must either be 0 or 1!" };
                                 }
                                 return true;
                             }
                         },
                        { text: 'Added On', datafield: 'AddedDate', filtertype: 'date', width: '10%', cellsalign: 'center', renderer: columnsrenderer, sortable: true, cellsformat: 'dd/MM/yyyy', cellbeginedit: isEditable },
                        {
                            text: 'Active', datafield: 'Active', filtertype: 'textbox', cellsalign: 'center', width: '10%', renderer: columnsrenderer, sortable: true,
                            validation: function (cell, value) {
                                if (value > 1 || value < 0) {
                                    return { result: false, message: "Must either be 0 or 1!" };
                                }
                                return true;
                            }
                        },
                        { text: 'Afilliate Id', datafield: 'FamobiId', filtertype: 'textbox', cellsrenderer: cellsrenderer, renderer: columnsrenderer, width: '8%', sortable: true },
                        { text: 'Sync Tunnl', datafield: 'SyncTunnl', filtertype: 'textbox', cellsrenderer: syncRenderer, renderer: columnsrenderer, width: '8%', sortable: true },

                        //VGD-144
                        {
                            text: 'Edit', datafield: 'Edit', columntype: 'button', width: '6%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return 'Edit'
                            }, buttonclick: function (row) {
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                window.location = '/WhiteListDomains/Edit/' + id;
                            }
                        },

                        {
                            text: 'Delete', datafield: 'Delete', columntype: 'button', width: '8%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Delete";
                            }, buttonclick: function (row) {
                                editrowindex = row;
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                window.location = '/WhitelistDomains/Delete/' + id;
                            }
                        },
                        {
                            text: 'Games', datafield: 'Games', columntype: 'button', width: '7%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Games";
                            }, buttonclick: function (row) {
                                editrowindex = row;
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "FamobiId");
                                window.location = '/WhitelistDomains/UnPublishedGames/' + id;
                            }
                        }
                    ]
                });
        });


        function TrimDomain(domain) {

            var words = ['www.', 'https://wwww.', 'http://wwww.'];

            for (var i = 0; i < words.length; i++) {

                if (domain.includes(words[i])) {
                    domain = domain.replace(words[i], '');
                    break;
                }
            }

            domain = domain.split('.')[0];
            return domain;
        }

    </script>
}

<div class="column">
    <div class="menu" style="text-align:left; color:black">
        <h2 style="width:100%; margin-left: 0 auto; margin-right:0 auto;">Whitelist Domains</h2>
        <div id="jqxgrid" style="width: 100% !important; margin-top:-20px;"></div>
    </div>
    <div id="jqxwindow">
        <div>
            &nbsp;
        </div>
        <div>
            <textarea id="text_input" rows="20" cols="80"></textarea>
            <br />
            <input type="button" value="Add" id="button_input" />
            <input type="button" value="Cancel" id="button_no" />
        </div>
    </div>
</div>

Views/WhitelistDomains/UnPublishedDomains.cshtml
@{
    ViewBag.Title = "UnPublishedDomains";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section scripts{
    <script>
        $(document).ready(function () {
            var source =
                {
                    datafields:
                    [
                        { name: 'Id', type: 'string' },
                        { name: 'Domain', type: 'string' },
                        { name: 'AffiliateId', type: 'string' },
                        { name: 'DomainId', type: 'int' },
                        { name: 'CreatedDate', type: 'date' }
                    ],
                    datatype: "json",
                    url: "/WhitelistDomains/GetUnPublishedDomains/@ViewBag.UnPublishedGameId",
                    filter: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'filter');
                    },
                    // update the grid and send a request to the server.
                    sort: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'sort');
                    },
                    root: "Rows",
                    beforeprocessing: function (data) {
                        source.totalrecords = data.TotalRows;
                    }
                };

            var dataAdapter = new $.jqx.dataAdapter(source);

            var columnsrenderer = function (value) {
                return '<div style="text-align: center; margin-top:10px;"><b>' + value + '</b></div>';
            }

            $("#jqxgrid").jqxGrid(
                {
                    width: "100%",
                    source: dataAdapter,
                    showfilterrow: true,
                    editable: false,
                    filterable: true,
                    pageable: true,
                    pagesize: 20,
                    autoheight: true,
                    virtualmode: true,
                    selectionmode: 'multiplecellsextended',
                    enablebrowserselection: true,
                    rendergridrows: function (obj) {
                        return obj.data;
                    },
                    columns:
                    [
                        { text: 'Id', datafield: 'Id', renderer: columnsrenderer, width: "20%", filterable: false },
                        { text: 'Domain', datafield: 'Domain', filtertype: 'textbox', renderer: columnsrenderer, width: "25%" },
                        { text: 'AffiliateId', datafield: 'AffiliateId', filtertype: 'textbox', renderer: columnsrenderer, width: "30%" },
                        { text: 'CreatedDate', datafield: 'CreatedDate', filtertype: 'date', cellsformat: 'dd/MM/yyyy', width: "20%", filterable: false },
                          {
                              text: 'Edit', datafield: 'Edit', columntype: 'button', width: '5%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                  return 'Edit'
                              }, buttonclick: function (row) {
                                  var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "DomainId");
                                  window.location = '/WhiteListDomains/Edit/' + id;
                              }
                          }
                    ]
                });
        });


        function TrimDomain(domain) {

            var words = ['www.', 'https://wwww.', 'http://wwww.'];

            for (var i = 0; i < words.length; i++) {

                if (domain.includes(words[i])) {
                    domain = domain.replace(words[i], '');
                    break;
                }
            }

            domain = domain.split('.')[0];
            return domain;
        }
    </script>
}

<div class="column">
    <div class="menu" style="text-align:left; color:black">
        <h2 style="width:100%; margin-left: 0 auto; margin-right:0 auto;">Unpublished Domains For @ViewBag.Game</h2>
        <div id="jqxgrid" style="width: 100% !important; margin-top:-20px;"></div>
        <div id="ordersGrid" style="width: 100% !important;"></div>
    </div>
</div>